import { type NonUndefined } from '@sequelize/utils';
import type * as Tedious from 'tedious';
export type InlinedTediousOptions = Omit<NonUndefined<Tedious.ConnectionConfiguration['options']>, 'enableAnsiNullDefault' | 'camelCaseColumns' | 'columnNameReplacer' | 'enableQuotedIdentifier' | 'useUTC' | 'useColumnNames' | 'isolationLevel'>;
export declare const INLINED_OPTION_OBJ: {
    readonly abortTransactionOnError: undefined;
    readonly appName: undefined;
    readonly cancelTimeout: undefined;
    readonly connectTimeout: undefined;
    readonly connectionIsolationLevel: undefined;
    readonly connectionRetryInterval: undefined;
    readonly connector: undefined;
    readonly cryptoCredentialsDetails: undefined;
    readonly database: undefined;
    readonly dateFormat: undefined;
    readonly datefirst: undefined;
    readonly debug: undefined;
    readonly enableAnsiNull: undefined;
    readonly enableAnsiPadding: undefined;
    readonly enableAnsiWarnings: undefined;
    readonly enableArithAbort: undefined;
    readonly enableConcatNullYieldsNull: undefined;
    readonly enableCursorCloseOnCommit: undefined;
    readonly enableImplicitTransactions: undefined;
    readonly enableNumericRoundabort: undefined;
    readonly encrypt: undefined;
    readonly fallbackToDefaultDb: undefined;
    readonly instanceName: undefined;
    readonly language: undefined;
    readonly localAddress: undefined;
    readonly lowerCaseGuids: undefined;
    readonly maxRetriesOnTransientErrors: undefined;
    readonly multiSubnetFailover: undefined;
    readonly packetSize: undefined;
    readonly port: undefined;
    readonly readOnlyIntent: undefined;
    readonly requestTimeout: undefined;
    readonly rowCollectionOnDone: undefined;
    readonly rowCollectionOnRequestCompletion: undefined;
    readonly serverName: undefined;
    readonly tdsVersion: undefined;
    readonly textsize: undefined;
    readonly trustServerCertificate: undefined;
    readonly workstationId: undefined;
};
export declare const INLINED_OPTION_NAMES: readonly ("port" | "encrypt" | "language" | "localAddress" | "lowerCaseGuids" | "tdsVersion" | "abortTransactionOnError" | "appName" | "cancelTimeout" | "connectionRetryInterval" | "connector" | "connectTimeout" | "connectionIsolationLevel" | "cryptoCredentialsDetails" | "database" | "datefirst" | "dateFormat" | "debug" | "enableAnsiNull" | "enableAnsiPadding" | "enableAnsiWarnings" | "enableArithAbort" | "enableConcatNullYieldsNull" | "enableCursorCloseOnCommit" | "enableImplicitTransactions" | "enableNumericRoundabort" | "fallbackToDefaultDb" | "instanceName" | "maxRetriesOnTransientErrors" | "multiSubnetFailover" | "packetSize" | "readOnlyIntent" | "requestTimeout" | "rowCollectionOnDone" | "rowCollectionOnRequestCompletion" | "serverName" | "textsize" | "trustServerCertificate" | "workstationId")[];
export declare const CONNECTION_OPTION_NAMES: readonly ("port" | "server" | "encrypt" | "language" | "localAddress" | "lowerCaseGuids" | "tdsVersion" | "abortTransactionOnError" | "appName" | "cancelTimeout" | "connectionRetryInterval" | "connector" | "connectTimeout" | "connectionIsolationLevel" | "cryptoCredentialsDetails" | "database" | "datefirst" | "dateFormat" | "debug" | "enableAnsiNull" | "enableAnsiPadding" | "enableAnsiWarnings" | "enableArithAbort" | "enableConcatNullYieldsNull" | "enableCursorCloseOnCommit" | "enableImplicitTransactions" | "enableNumericRoundabort" | "fallbackToDefaultDb" | "instanceName" | "maxRetriesOnTransientErrors" | "multiSubnetFailover" | "packetSize" | "readOnlyIntent" | "requestTimeout" | "rowCollectionOnDone" | "rowCollectionOnRequestCompletion" | "serverName" | "textsize" | "trustServerCertificate" | "workstationId" | "authentication")[];
export declare const STRING_CONNECTION_OPTION_NAMES: readonly ("server" | "encrypt" | "language" | "localAddress" | "tdsVersion" | "appName" | "database" | "dateFormat" | "instanceName" | "serverName" | "workstationId")[];
export declare const BOOLEAN_CONNECTION_OPTION_NAMES: readonly ("encrypt" | "lowerCaseGuids" | "abortTransactionOnError" | "enableAnsiNull" | "enableAnsiPadding" | "enableAnsiWarnings" | "enableArithAbort" | "enableConcatNullYieldsNull" | "enableCursorCloseOnCommit" | "enableImplicitTransactions" | "enableNumericRoundabort" | "fallbackToDefaultDb" | "multiSubnetFailover" | "readOnlyIntent" | "rowCollectionOnDone" | "rowCollectionOnRequestCompletion" | "trustServerCertificate")[];
export declare const NUMBER_CONNECTION_OPTION_NAMES: readonly ("port" | "cancelTimeout" | "connectionRetryInterval" | "connectTimeout" | "connectionIsolationLevel" | "datefirst" | "maxRetriesOnTransientErrors" | "packetSize" | "requestTimeout" | "textsize")[];
