"use strict";
var import_core = require("@sequelize/core");
var import_mssql = require("@sequelize/mssql");
var import_chai = require("chai");
describe("MsSqlDialect#parseConnectionUrl", () => {
  const dialect = new import_core.Sequelize({ dialect: import_mssql.MsSqlDialect }).dialect;
  it("parses connection URL", () => {
    const options = dialect.parseConnectionUrl(
      "sqlserver://user:password@localhost:1234/dbname?language=en"
    );
    (0, import_chai.expect)(options).to.deep.eq({
      server: "localhost",
      port: 1234,
      database: "dbname",
      language: "en",
      authentication: {
        type: "default",
        options: {
          userName: "user",
          password: "password"
        }
      }
    });
  });
});
//# sourceMappingURL=dialect.test.js.map
