import type { BulkDeleteQueryOptions, CreateDatabaseQueryOptions, Expression, ListDatabasesQueryOptions, ListSchemasQueryOptions, ListTablesQueryOptions, RemoveIndexQueryOptions, RenameTableQueryOptions, ShowConstraintsQueryOptions, TableOrModel, TruncateTableQueryOptions } from '@sequelize/core';
import { AbstractQueryGenerator } from '@sequelize/core';
import type { EscapeOptions } from '@sequelize/core/_non-semver-use-at-your-own-risk_/abstract-dialect/query-generator-typescript.js';
import type { MsSqlDialect } from './dialect.js';
import { MsSqlQueryGeneratorInternal } from './query-generator.internal.js';
/**
 * Temporary class to ease the TypeScript migration
 */
export declare class MsSqlQueryGeneratorTypeScript extends AbstractQueryGenerator {
    #private;
    constructor(dialect: MsSqlDialect, internals?: MsSqlQueryGeneratorInternal);
    createDatabaseQuery(database: string, options?: CreateDatabaseQueryOptions): string;
    listDatabasesQuery(options?: ListDatabasesQueryOptions): string;
    listSchemasQuery(options?: ListSchemasQueryOptions): string;
    describeTableQuery(tableName: TableOrModel): string;
    listTablesQuery(options?: ListTablesQueryOptions): string;
    renameTableQuery(beforeTableName: TableOrModel, afterTableName: TableOrModel, options?: RenameTableQueryOptions): string;
    truncateTableQuery(tableName: TableOrModel, options?: TruncateTableQueryOptions): string;
    showConstraintsQuery(tableName: TableOrModel, options?: ShowConstraintsQueryOptions): string;
    showIndexesQuery(tableName: TableOrModel): string;
    removeIndexQuery(tableName: TableOrModel, indexNameOrAttributes: string | string[], options?: RemoveIndexQueryOptions): string;
    createSavepointQuery(savepointName: string): string;
    rollbackSavepointQuery(savepointName: string): string;
    generateTransactionId(): string;
    jsonPathExtractionQuery(sqlExpression: string, path: ReadonlyArray<number | string>, unquote: boolean): string;
    formatUnquoteJson(arg: Expression, options?: EscapeOptions): string;
    versionQuery(): string;
    getUuidV4FunctionCall(): string;
    bulkDeleteQuery(tableOrModel: TableOrModel, options: BulkDeleteQueryOptions): string;
}
