import type { CommitTransactionOptions, CreateSavepointOptions, RollbackSavepointOptions, RollbackTransactionOptions, StartTransactionOptions } from '@sequelize/core';
import { AbstractQueryInterface, Transaction } from '@sequelize/core';
import type { MsSqlDialect } from './dialect.js';
import { MsSqlQueryInterfaceInternal } from './query-interface.internal.js';
export declare class MsSqlQueryInterfaceTypescript<Dialect extends MsSqlDialect = MsSqlDialect> extends AbstractQueryInterface<Dialect> {
    #private;
    constructor(dialect: Dialect, internalQueryInterface?: MsSqlQueryInterfaceInternal);
    _commitTransaction(transaction: Transaction, _options: CommitTransactionOptions): Promise<void>;
    _createSavepoint(transaction: Transaction, options: CreateSavepointOptions): Promise<void>;
    _rollbackSavepoint(transaction: Transaction, options: RollbackSavepointOptions): Promise<void>;
    _rollbackTransaction(transaction: Transaction, _options: RollbackTransactionOptions): Promise<void>;
    _startTransaction(transaction: Transaction, options: StartTransactionOptions): Promise<void>;
}
